package com.bjtdba.userCenter.dao;

import com.bjtdba.entity.userCenter.UserVideo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 用户视频表(UserVideo)表数据库访问层
 *
 * @author 何海强
 * @since 2022-11-12 09:33:20
 */
@Mapper
public interface UserVideoDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserVideo queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param userVideo 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<UserVideo> queryAllByLimit(UserVideo userVideo);

    /**
     * 统计总行数
     *
     * @param userVideo 查询条件
     * @return 总行数
     */
    long count(UserVideo userVideo);

    /**
     * 新增数据
     *
     * @param userVideo 实例对象
     * @return 影响行数
     */
    int insert(UserVideo userVideo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserVideo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<UserVideo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserVideo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<UserVideo> entities);

    /**
     * 修改数据
     *
     * @param userVideo 实例对象
     * @return 影响行数
     */
    int update(UserVideo userVideo);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(String[] ids);

    List<UserVideo> queryAllByLike(UserVideo userVideo);

}

